import 'dart:collection';

import 'package:miodi/core/module.dart';
import 'package:miodi/core/providers.dart';

abstract class MiodiComponent {
  final HashMap<Type, Provider> componentConfiguration = HashMap();
  MiodiComponent() {
    modules.forEach((module) {
      componentConfiguration.addAll(module.moduleConfiguration);
    });
  }

  List<MiodiModule> get modules;

  String get componentNamespace => 'Miodi';

  T get<T>() => componentConfiguration[T].provide() as T;
}