class FactoryProvider<T> extends Provider<T> {
  final Creator _creator;

  FactoryProvider(Type T, this._creator): super(T);

  @override
  T provide() => _creator();
}

class SingletonProvider<T> extends Provider<T> {
  final Creator _creator;
  T _instance;

  SingletonProvider(Type T, this._creator) : super(T);

  @override
  T provide() {
    if (_instance == null) _instance = _creator();
    return _instance;
  }
}

abstract class Provider<T> {
  final Type _type;
  Provider(this._type);
  Type get provideType => _type;

  T provide();
}

typedef T Creator<T>();